package com.dsic.gj_erp.controller.jcsj;


import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.EmSbjbb;
import com.dsic.gj_erp.bean.request.EmSbjbbBean;
import com.dsic.gj_erp.service.jcsj.EmSbjbbService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@RestController
@RequestMapping("/emSbjbb")
@Api(tags = "设备信息")
public class EmSbjbbController {
    @Autowired
    EmSbjbbService emSbjbbService;


    @ApiOperation(value = "查询")
    @PostMapping(value = "/getList")
    public ResultBean getList(@RequestBody EmSbjbbBean emSbjbbBean) {
        List<EmSbjbb> emSbjbbs= emSbjbbService.getList(emSbjbbBean);
        return new ResultBean(emSbjbbs);
    }

    @AuthFunction()
    @ApiOperation(value = "批量新增")
    @PostMapping(value = "/save")
    public ResultBean save(@RequestBody List<EmSbjbb> sbjbbs, HttpServletRequest request) {
        emSbjbbService.save(sbjbbs,request);

        return new ResultBean();
    }

    @ApiOperation(value = "批量修改")
    @PostMapping(value = "/update")
    public ResultBean update(@RequestBody List<EmSbjbb> sbjbbs) {
        emSbjbbService.update(sbjbbs);

        return new ResultBean();
    }

    @ApiOperation(value = "批量删除")
    @PostMapping(value = "/delete")
    public ResultBean save(@RequestBody List<EmSbjbb> sbjbbs) {
        emSbjbbService.delete(sbjbbs);

        return new ResultBean();
    }

    @ApiOperation(value = "供应商")
    @PostMapping(value = "/getGYS")
    public ResultBean getGYS() {
        List<Map> emSbjbbs= emSbjbbService.getGYS();

        return new ResultBean(emSbjbbs);
    }

    @ApiOperation(value = "所有供货商")
    @PostMapping(value = "/getGhs")
    public ResultBean getGhs() {
        List<Map> emSbjbbs= emSbjbbService.getGhs();
        return new ResultBean(emSbjbbs);
    }

    @ApiOperation(value = "设备分类")
    @PostMapping(value = "/getSBLX")
    public ResultBean getSBLX() {
        List<Map> emSbjbbs= emSbjbbService.getSBLX();
        return new ResultBean(emSbjbbs);
    }

    @ApiOperation(value = "部门对应设备名称和编号")
    @PostMapping(value = "/getBMMCBM")
    public ResultBean getBMMCBM() {
        Map<String,List<Map>> emSbjbbs= emSbjbbService.getBMMCBM();

        return new ResultBean(emSbjbbs);
    }
}

