package com.dsic.gj_erp.jszb.control;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.EasyExcel;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.YdjhImportNew;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.exception.ServiceException;
import com.dsic.gj_erp.jszb.entity.PartFlowInfo;
import com.dsic.gj_erp.jszb.excel.ExcelFlowInfoListener;
import com.dsic.gj_erp.jszb.service.FlowInfoService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Objects;

@RestController
@RequestMapping("jszb")
@AllArgsConstructor
public class JszbController {

    private final FlowInfoService flowInfoService;

    @GetMapping("exportJSzb")
    public void exportJSzb(String ch,String begin,String end){

    }

    @GetMapping("getFlowInfoList")
    public ResultBean<?> getFlowInfoList(String ch,String begin,String end) {
        List<PartFlowInfo> list = flowInfoService.list(Wrappers.<PartFlowInfo>lambdaQuery()
                .eq(PartFlowInfo::getCh, ch)
                .eq(StrUtil.isEmpty(end) && StrUtil.isNotEmpty(begin), PartFlowInfo::getPl, begin)
                .between(StrUtil.isAllNotEmpty(begin, end), PartFlowInfo::getPl, begin, end)
                .orderByAsc(PartFlowInfo::getPl,PartFlowInfo::getFd)
        );
        return new ResultBean<>(list);
    }

    @PostMapping("importFLowInfo")
    public ResultBean<?> importFLowInfo(@RequestParam("file") MultipartFile file) throws IOException {
        ExcelFlowInfoListener objectListener = new ExcelFlowInfoListener();
        EasyExcel.read(file.getInputStream(), PartFlowInfo.class, objectListener).sheet(0).headRowNumber(1).doRead();

        List<PartFlowInfo> objList = objectListener.getObjectList();
        List<String> errors = objectListener.getErrors();
        List<PartFlowInfo> updateList=new ArrayList<>();
        objList.forEach(item->{
            PartFlowInfo one = flowInfoService.getOne(Wrappers.<PartFlowInfo>lambdaQuery()
                    .eq(StrUtil.isNotEmpty(item.getCh()),PartFlowInfo::getCh, item.getCh())
                    .eq(StrUtil.isNotEmpty(item.getCh()),PartFlowInfo::getPartName,item.getPartName())
                    .eq(StrUtil.isNotEmpty(item.getProject()),PartFlowInfo::getCh,item.getProject())
                    .eq(StrUtil.isNotEmpty(item.getProject()),PartFlowInfo::getPartName,item.getPartName0())
            );

            if (ObjUtil.isEmpty(one)){
                one = new PartFlowInfo();
            }

            BeanUtil.copyProperties(item,one,"id");

            if(item.getProject()!=null){
                one.setCh(item.getProject());
                one.setFd(item.getBlock());
                one.setPartName(item.getPartName0());
            }
            updateList.add(one);
        });

        flowInfoService.saveOrUpdateBatch(updateList);
        return new ResultBean<>(errors);
    }

}
