package com.dsic.gj_erp.pc.dto.data;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.dsic.gj_erp.bean.SpringContextHolder;
import com.dsic.gj_erp.bean.jhgk.DmSygdxq;
import com.dsic.gj_erp.pc.Constant;
import com.dsic.gj_erp.pc.service.设备产能接口;
import com.dsic.gj_erp.pc.设备产能;
import com.google.common.util.concurrent.AtomicDouble;
import lombok.Getter;
import lombok.Setter;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Getter
@Setter
public class 钢料需求 {
    private String dcCh;
    private String dcPl;
    private String dcFd;
    private String xzglxq;
    private String dzglxq;
    private List<Bom> bomList;
    private Map<String, AtomicDouble> 切割各设备需求量;
    private DateTime 均衡需求日期;

    public static 钢料需求 of(DmSygdxq qfxq){
        钢料需求 _钢料需求 = new 钢料需求();
        BeanUtil.copyProperties(qfxq,_钢料需求,"bomList");
        _钢料需求.bomList=qfxq.getBomList().stream()
                .map(item->Bom.of(_钢料需求.getXzglxq(),_钢料需求.getDzglxq(),item))
                .collect(Collectors.toList());
        return _钢料需求;
    }

    /**
     * 校验产能是否满足切割需求量
     */
    public void 校验产能是否满足切割需求量(){
        //从redis获取各切割设备产能
        设备产能接口 _设备产能接口 = getBean(设备产能接口.class);
        List<设备产能> 切割设备产能 = _设备产能接口.get().stream()
                .filter(item->item.get_工序()== Constant.工序.切割).collect(Collectors.toList());

    }

    public void 计算各设备切割需求量(){
        切割各设备需求量=new HashMap<>();
        this.bomList.forEach(item->{
            this.切割(item,"N1AX-N1AD");//一跨龙门
            this.切割(item,"N1LD");//一跨数控
            this.切割(item,"N2BX-N2BD-N2CX-N2CD-N2HX-N2HD");//二跨
//            this.切割(item,"N2TX-N2TD");//二跨转移4,5,6垮
            this.切割(item,"S2TX-S2TD");//二跨手工
            this.切割(item,"N3CX-N3CD");//三跨
            this.切割(item,"S3PX-S3PD");//三跨手工
            this.切割(item,"S3XX");//三跨手工
            this.切割(item,"N4PX-N4PD-N4XX-N2TX-N2TD");//456垮
        });
    }

    public void addBomList(List<Bom> list){
        this.bomList.addAll(list);
    }

    private void 切割(Bom item,String key){
        if (StrUtil.containsAny(item.getTzbh(),key.split("-"))){
            AtomicDouble aDouble = 切割各设备需求量.computeIfAbsent(key, k -> new AtomicDouble(0));
            aDouble.addAndGet(1);//按张计算
        }
    }

    private static <T> T getBean(Class<T> clazz) {
        return SpringContextHolder.getBean(clazz);
    }

    public DateTime get均衡需求日期(){
        if (this.均衡需求日期 ==null){
            return DateUtil.parse(this.xzglxq,"yyyy/MM/dd");
        }
        return (DateTime) this.均衡需求日期.clone();
    }

}
