package com.dsic.gj_erp.pc.dto;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.dsic.gj_erp.pc.Constant;
import com.dsic.gj_erp.pc.dto.data.Bom;
import com.google.common.util.concurrent.AtomicDouble;
import lombok.Getter;
import lombok.Setter;

import java.util.Map;
import java.util.Optional;
import java.util.concurrent.Semaphore;
import java.util.concurrent.atomic.AtomicBoolean;

import static com.dsic.gj_erp.pc.Manager.套料图所占工序的资源;

@Getter
@Setter
public class 资源 {
    private String date;
    private DateTime _date;
    private Map<Constant.工序,工序产能> 工序产能MAP;

    public void 占用资源(Constant.工序 工序,String 套料图号,double 产能消耗){
        工序产能 工序产能 = 工序产能MAP.get(工序);
        Optional.of(工序产能).ifPresent(it->{
            if (it.判断是否可以占用(产能消耗)){
                it.占用资源(套料图号,产能消耗);
                设置套料图所在资源(套料图号);
            }
        });
    }

    public boolean 判断切割设备是否可以被占用(Map<String, AtomicDouble> 切割各设备需求量){
        工序产能 工序产能 = 工序产能MAP.get(Constant.工序.切割);
        Map<String, 设备> 设备 = 工序产能.get设备();
        AtomicBoolean flag=new AtomicBoolean(true);
        设备.values().forEach(it->{
                AtomicDouble 产量=切割各设备需求量.get(it.getKey());
                if (产量!=null&&it.get占用()+产量.get()>it.产能){
                    flag.set(false);
                }
            });
        return flag.get();
    }

    public boolean 判断工序是否可以被占用(Constant.工序 _工序 ,double 产能消耗){
        工序产能 工序产能 = 工序产能MAP.get(_工序);
        AtomicBoolean atomicBoolean = new AtomicBoolean(false);
        Optional.ofNullable(工序产能).ifPresent(it->{
            if (it.判断是否可以占用(产能消耗)){
                atomicBoolean.set(true);
            }
        });
        return atomicBoolean.get();
    }

    public boolean 占用资源(Constant.工序 工序, Bom bom, double 产能消耗){
        AtomicBoolean atomicBoolean = new AtomicBoolean(false);
        工序产能 工序产能 = 工序产能MAP.get(工序);
        Optional.ofNullable(工序产能).ifPresent(it->{
            if (it.产能==0){
                return;
            }
            if (!it.判断是否可以占用(产能消耗)){
                bom.超出工序产能(工序);
            }
            it.占用资源(产能消耗,bom);
            设置套料图所在资源(bom.getTzbh());
            atomicBoolean.set(true);
        });
        return atomicBoolean.get();
    }

    private static Semaphore semaphore = new Semaphore(1);

    protected static 资源 读取套料图所在资源(String 套料图号) {
        try {
            semaphore.acquire();
            return 套料图所占工序的资源.get(套料图号);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }finally {
            semaphore.release();
        }
    }

    protected void 设置套料图所在资源(String 套料图号) {
        try {
            semaphore.acquire();
            套料图所占工序的资源.put(套料图号,this);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }finally {
            semaphore.release();
        }
    }

    public static 资源 of(String date,Map<Constant.工序,工序产能> 工序产能MAP){
        资源 资源 = new 资源();
        资源.date=date;

        资源._date= DateUtil.parse(date,"yyyy/MM/dd");
        资源.工序产能MAP=工序产能MAP;
        return 资源;
    }

    private 资源(){}

    public String toString(){
        return JSONObject.toJSONString(this);
    }
}
