package com.dsic.gj_erp.service.jhgk.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.bean.jcsj.DmCbxxp;
import com.dsic.gj_erp.bean.jhgk.DmSygdMx;
import com.dsic.gj_erp.bean.jhgk.DmSygdMxLj;
import com.dsic.gj_erp.bean.jhgk.DmSygdxq;
import com.dsic.gj_erp.bean.jhgk.YdjhImport;
import com.dsic.gj_erp.bean.jhgk.excel.JhxfExcel;
import com.dsic.gj_erp.bean.pgd.PgdTzjh;
import com.dsic.gj_erp.mapper.jhgk.DmSygdxqMapper;
import com.dsic.gj_erp.service.jcsj.DmBomService;
import com.dsic.gj_erp.service.jcsj.DmCbxxpService;
import com.dsic.gj_erp.service.jhgk.DmSygdMxService;
import com.dsic.gj_erp.service.pgd.PgdTzjhService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.support.TransactionTemplate;

import javax.servlet.http.HttpServletRequest;
import java.util.*;
import java.util.stream.Collectors;

@Service
@AllArgsConstructor
public class YdjhImportService {

    private final DmSygdxqMapper sygdxqMapper;
    private final IYdjhImportService importService;
    private final DmBomService bomService;
    private final DmCbxxpService dmCbxxpService;
    private final PgdTzjhService tzjhService;
    private final TransactionTemplate transactionTemplate;
    private final DmSygdMxService sygdMxService;

    public List<YdjhImport> listByFileName(String fileName) {
        List<YdjhImport> list = importService.list(Wrappers.<YdjhImport>lambdaQuery()
                .eq(StrUtil.isNotEmpty(fileName), YdjhImport::getFileName, fileName)
                .orderByAsc(YdjhImport::getId)
        );
        //修正个产线数量
        //todo 需根据于庆胜最新格式开发
//        list.stream().filter(item->StrUtil.isNotEmpty(item.getDcPl()))
//                .forEach(item->{
//                    List<DmBom> bomList = bomService.getBomUni(item.getDcCh(),item.getDcPl());
//                    if (StrUtil.isNotEmpty(item.getSl())){
//                        item.setBs1(bomList.size()+"");
//                    }
//
//                    if (StrUtil.isNotEmpty(item.getEkskks())){
//
//                    }
//
//                });
        return list;
    }

    public List<YdjhImport> list(String begin, String end) {
        return importService.list(Wrappers.<YdjhImport>lambdaQuery()
                .between(YdjhImport::getFdxq, begin, end).or().between(YdjhImport::getQwbjs, begin, end)
                .orderByAsc(YdjhImport::getId)
        );
    }

    public void handler(List<JhxfExcel> objList,String fileName, HttpServletRequest request) {
        List<YdjhImport> ydjhImports = this.executeYdjhImport(objList);

        List<YdjhImport> list = ydjhImports.stream()
//                .filter(YdjhImport::isAvailable)
//                .filter(item -> !item.getDcPl().contains("-"))//去除T型材
//                .filter(item -> !item.getDcPl().contains("/"))//去除T型材
//                .filter(item -> !item.getDcPl().contains("Q"))
                .filter(item -> StrUtil.isAllNotEmpty(item.getDcCh(),item.getDcPl()))
                .collect(Collectors.toList());
        List<DmSygdMx> sygdMxList = this.execute(list);

        transactionTemplate.execute((status)->{
            ydjhImports.stream().filter(item -> StrUtil.isAllNotEmpty(item.getDcCh(),item.getDcPl()))
            .forEach(item->{
                item.setFileName(fileName);
                String dcPl=item.getDcPl();
                if (item.getDcPl().contains("Q")) {
                    dcPl=item.getDcPl().replace("Q", "");
                }

                try {
                    dcPl = String.format("%03d", Integer.parseInt(dcPl));
                } catch (Exception ignored) {
                }

                importService.remove(new QueryWrapper<YdjhImport>()
                        .eq("dc_ch", item.getDcCh())
                        .eq("dc_pl", item.getDcPl())
                );

                sygdMxService.remove(new QueryWrapper<DmSygdMx>()
                        .eq("dc_ch", item.getDcCh())
                        .eq("dc_pl", dcPl)
                );
            });
            sygdMxService.saveBatch(sygdMxList);
            ydjhImports.forEach(importService::save);

            //没有基础数据的计划生成图纸计划
            String yhms= (String) request.getAttribute("yhms");
            String date= DateUtil.date().toString("yyyy/MM/dd");
            List<PgdTzjh> tzjhList = new ArrayList<>();

            HashMap<String, YdjhImport> map = new HashMap<>();
            ydjhImports.stream()
                    .filter(item -> !StrUtil.equals(item.getExtData(), "1")||item.getExtData()!=null)
                    .filter(item -> StrUtil.isAllNotEmpty(item.getDcCh(),item.getDcPl()))
                    .forEach(item->{
                        YdjhImport ydjhImport = map.get(item.getDcCh() + item.getDcPl());
                        if (ydjhImport==null){
                            map.put(item.getDcCh() + item.getDcPl(),item);
                            String dcPl=item.getDcPl();
                            if (item.getDcPl().contains("Q")) {
                                dcPl=item.getDcPl().replace("Q", "");
                            }

                            try {
                                dcPl = String.format("%03d", Integer.parseInt(dcPl));
                            } catch (Exception ignored) {
                            }

                            tzjhService.remove(Wrappers.<PgdTzjh>lambdaQuery()
                                    .eq(PgdTzjh::getCzbh,item.getDcCh())
                                    .eq(PgdTzjh::getPl,dcPl)
                                    .and(it->it.isNull(PgdTzjh::getFkrq).or().eq(PgdTzjh::getFkrq,""))
                            );

                            PgdTzjh dmTzjh = PgdTzjh.of(item,dcPl);
                            dmTzjh.setBzry(yhms);
                            dmTzjh.setBzrq(date);
                            dmTzjh.setXfry(yhms);
                            dmTzjh.setXfrq(date);
                            dmTzjh.setQfxqrqxz(item.getQfxqrqxz());
                            dmTzjh.setQfxqrqdz(item.getQfxqrqdz());
                            dmTzjh.setQgxqrq(item.getQgrq());
                            tzjhList.add(dmTzjh);
                        }
                    });
            tzjhService.saveBatch(tzjhList);
            return true;
        });

    }

    public List<YdjhImport> executeYdjhImport(List<JhxfExcel> objList) {
        List<YdjhImport> list = new ArrayList<>();
        for (JhxfExcel item : objList) {
            YdjhImport jh = new YdjhImport();
            BeanUtil.copyProperties(item, jh);

            jh.setZt("0");
            list.add(jh);
        }
        return list;
    }

    /**
     * 月度计划导入,不使用月度计划只能排产功能前提下使用该功能导入月度计划
     */
    public List<DmSygdMx> execute(List<YdjhImport> objList) {
        HashMap<String, Object> _map = new HashMap<>();
        List<DmSygdMx> addList = new ArrayList<>();
        objList.forEach(item->{
            String _dcPl=item.getDcPl();
            List<String> plList=new ArrayList<>();
            if (_dcPl.contains("Q")) {
                plList.add(item.getDcPl().replace("Q", ""));
                item.setQwbBs(true);
            }else if(_dcPl.contains("-")||_dcPl.contains("/")){
                String[] split = _dcPl.split("/");
                for (String s : split) {
                    String[] split1 = s.split("-");
                    if (split1.length == 1) {
                        plList.add(split1[0]);
                    } else {
                        for (int j = Integer.parseInt(split1[0]); j <= Integer.parseInt(split1[1].replace("D","")); j++) {
                            plList.add(j + "");
                        }
                    }
                }
            }

            for (String dcPl : plList) {
                try {
                    dcPl = String.format("%03d", Integer.parseInt(dcPl));
                } catch (Exception ignored) {
                }

                Object o = _map.get(item.getDcCh() + item.getDcPl());
                if(o==null){
                    _map.put(item.getDcCh() + item.getDcPl(),item);
                }else{
                    item.setExtData(item.getExtData());
                    item.setQfxqrqxz(item.getQfxqrqxz());
                    item.setQfxqrqdz(item.getQfxqrqdz());
                    return;
                }

                List<DmBom> bomList = bomService.getBomWithYlbs(item.getDcCh(), dcPl);

                String dcCh;
                //基础数据未导入,使用目标船只
                if (ObjUtil.isEmpty(bomList)) {
                    DmCbxxp one = dmCbxxpService.getOne(Wrappers.<DmCbxxp>lambdaQuery()
                            .eq(DmCbxxp::getCbbm, item.getDcCh())
                    );
                    if (one != null) {
                        dcCh = one.getCbbm();
                        item.setExtData(dcCh);//使用目标船只基础数据
                        bomList = bomService.getBomWithYlbs(dcCh, dcPl);
                        if (ObjUtil.isEmpty(bomList)) {
                            DmSygdMx dmSygdMx = this.initDefault(item,dcPl);
                            dmSygdMx.setDcCh1(dcCh);

                            item.setExtData("0");//无基础数据
                            return;
                        }
                    } else {
                        item.setExtData("0");//无基础数据
                        DmSygdMx dmSygdMx = this.initDefault(item,dcPl);
                        addList.add(dmSygdMx);
                        return;
                    }
                } else {
                    item.setExtData("1");//有基础数据
                }

                List<DmSygdxq> dmSygdxqs = sygdxqMapper.selectList(Wrappers.<DmSygdxq>lambdaQuery()
                        .eq(DmSygdxq::getDcCh, item.getDcCh()).eq(DmSygdxq::getDcPl, dcPl));

                if (ObjUtil.isNotEmpty(dmSygdxqs)){
                    DmSygdxq dmSygdxq = dmSygdxqs.get(0);
                    item.setQfxqrqxz(dmSygdxq.getXzglxq());
                    item.setQfxqrqdz(dmSygdxq.getDzglxq());
                }

                HashMap<Object, DmSygdxq> map = new HashMap<>();
                for (DmSygdxq xq : dmSygdxqs) {
                    String pl = xq.getDcPl();
                    String fd = xq.getDcFd();
                    map.put(item.getDcCh() + pl + fd, xq);
                }
                List<DmSygdMxLj> ljList = this.initLj(item.getDcCh(), map, bomList);

                List<DmSygdMx> sygdMxes=new ArrayList<>();
                if (StrUtil.isNotEmpty(item.getSl())){
                    if (item.getQwbBs()) {
                        ljList=ljList.stream().filter(it -> "3".equals(it.getTzbh().substring(5, 6)))
                                .collect(Collectors.toList());
                    } else {
                        ljList=ljList.stream().filter(it -> !"3".equals(it.getTzbh().substring(5, 6)))
                                .collect(Collectors.toList());
                    }
                    sygdMxes = this.initBySl(item, ljList);
                    item.setBs1(sygdMxes.size()+"");
                    addList.addAll(sygdMxes);
                }

                if (item.getPkqgjs() != null) {
                    List<DmSygdMx> _sygdMxes = sygdMxes.stream().filter(it -> "7".equals(it.getKw())).collect(Collectors.toList());
                    if (!_sygdMxes.isEmpty()) {
                        for (DmSygdMx sygdMx : _sygdMxes) {
                            this.updateByYklm(item, sygdMx);
                        }
                        item.setYklm(_sygdMxes.size()+"");
                    } else {
                        List<DmSygdMxLj> _ljlist = ljList.stream().filter(it -> "7".equals(it.getKw())).collect(Collectors.toList());
                        if (!_ljlist.isEmpty()){
                            List<DmSygdMx> list = this.initByYklm(item, _ljlist);
                            addList.addAll(list);
                            item.setYklm(list.size()+"");
                        }

                    }

                    List<DmSygdMx> _sygdMxes1 = sygdMxes.stream().filter(it -> "8".equals(it.getKw())).collect(Collectors.toList());
                    if (!_sygdMxes1.isEmpty()) {
                        for (DmSygdMx dmSygdMx : _sygdMxes1) {
                            this.updateByYksk(item, dmSygdMx);
                        }
                        item.setYksk(_sygdMxes1.size()+"");
                    } else {
                        List<DmSygdMxLj> _ljlist = ljList.stream().filter(it -> "8".equals(it.getKw())).collect(Collectors.toList());
                        if (!_ljlist.isEmpty()) {
                            List<DmSygdMx> list = this.initByYksk(item, _ljlist);
                            addList.addAll(list);
                            item.setYksk(list.size()+"");
                        }
                    }
                }

                if (item.getLmqgks() != null) {
                    List<DmSygdMx> _sygdMxes = sygdMxes.stream().filter(it -> "5".equals(it.getKw())).collect(Collectors.toList());
                    if (!_sygdMxes.isEmpty()) {
                        for (DmSygdMx sygdMx : _sygdMxes) {
                            this.updateByEklm(item, sygdMx);
                        }
                        item.setEklmbs(_sygdMxes.size()+"");
                    } else {
                        List<DmSygdMxLj> _ljlist = ljList.stream().filter(it -> "5".equals(it.getKw())).collect(Collectors.toList());
                        if (!_ljlist.isEmpty()){
                            List<DmSygdMx> list = this.initByEklmbs(item, _ljlist);
                            addList.addAll(list);
                            item.setEklmbs(list.size()+"");
                        }
                    }
                }

                if (item.getEkskks() != null) {
                    List<DmSygdMx> _sygdMxes = sygdMxes.stream().filter(it -> "9".equals(it.getKw())).collect(Collectors.toList());
                    if (!_sygdMxes.isEmpty()) {
                        for (DmSygdMx sygdMx : _sygdMxes) {
                            this.updateByEksk(item, sygdMx);
                        }
                        item.setEksk(_sygdMxes.size()+"");
                    } else {
                        List<DmSygdMxLj> _ljlist = ljList.stream().filter(it -> "9".equals(it.getKw())).collect(Collectors.toList());
                        if (!_ljlist.isEmpty()) {
                            List<DmSygdMx> list = this.initByEksk(item, _ljlist);
                            addList.addAll(list);
                            item.setEksk(list.size()+"");
                        }
                    }
                }

                if (item.getSkskqgks() != null) {
                    List<DmSygdMx> _sygdMxes = sygdMxes.stream().filter(it -> "14".equals(it.getKw())).collect(Collectors.toList());
                    if (!_sygdMxes.isEmpty()) {
                        for (DmSygdMx sygdMx : _sygdMxes) {
                            this.updateBySksk(item, sygdMx);
                        }
                        item.setSksk(_sygdMxes.size()+"");
                    } else {
                        List<DmSygdMxLj> _ljlist = ljList.stream().filter(it -> "14".equals(it.getKw())).collect(Collectors.toList());
                        if (!_ljlist.isEmpty()) {
                            List<DmSygdMx> list = this.initBySksk(item, _ljlist);
                            addList.addAll(list);
                            item.setSksk(list.size()+"");
                        }
                    }
                }

                if (item.getPtks() != null) {
                    List<DmSygdMx> _sygdMxes = sygdMxes.stream().filter(it -> "6".equals(it.getKw())).collect(Collectors.toList());
                    if (!_sygdMxes.isEmpty()) {
                        for (DmSygdMx sygdMx : _sygdMxes) {
                            this.updateBySkpt(item, sygdMx);
                        }
                        item.setSkpt(_sygdMxes.size()+"");
                    } else {
                        List<DmSygdMxLj> _ljlist = ljList.stream().filter(it -> "6".equals(it.getKw())).collect(Collectors.toList());
                        if(!_ljlist.isEmpty()){
                            List<DmSygdMx> list = this.initBySkpt(item, _ljlist);
                            addList.addAll(list);
                            item.setSkpt(list.size()+"");
                        }
                    }
                }

                if (item.getSkqgks() != null) {
                    List<DmSygdMx> _sygdMxes = sygdMxes.stream().filter(it -> "15".equals(it.getKw())).collect(Collectors.toList());
                    if (!_sygdMxes.isEmpty()) {
                        for (DmSygdMx sygdMx : _sygdMxes) {
                            this.updateBySkbs(item, sygdMx);
                        }
                        if ("T型材".equals(item.getDcFd())&&"Z".equals(item.getZl())){
                            long count = _sygdMxes.stream().filter(it -> it.getZl().equals("1110")).count();
                            item.setSkbs(count+"");
                        }else if("机器人肘板".equals(item.getDcFd())&&"X".equals(item.getZl())){
                            long count = _sygdMxes.stream().filter(it -> it.getZl().equals("1010")).count();
                            item.setSkbs(count+"");
                        }else {
                            item.setSkbs(_sygdMxes.size()+"");
                        }
                    } else {
                        List<DmSygdMxLj> _ljlist = ljList.stream().filter(it -> "15".equals(it.getKw())).collect(Collectors.toList());
                        if (_ljlist.isEmpty()){
                            List<DmSygdMx> list = this.initBySkbs(item, _ljlist);
                            addList.addAll(list);
                            if ("T型材".equals(item.getDcFd())&&"Z".equals(item.getZl())){
                                long count = _ljlist.stream().filter(it -> it.getZl().equals("1110")).count();
                                item.setSkbs(count+"");
                            }else if("机器人肘板".equals(item.getDcFd())&&"X".equals(item.getZl())){
                                long count = _ljlist.stream().filter(it -> it.getZl().equals("1010")).count();
                                item.setSkbs(count+"");
                            }else {
                                item.setSkbs(_ljlist.size()+"");
                            }
                        }
                    }
                }
            }
        });

//        this.saveBatch(addList);
        return addList;
    }

    private List<DmSygdMx> initBySl(YdjhImport item, List<DmSygdMxLj> bomList) {
        List<DmSygdMx> addList = new ArrayList<>();

        if (item.getSl() != null) {
            ArrayList<DmSygdMxLj> list = bomList.stream().collect(
                    Collectors.collectingAndThen(
                            Collectors.toCollection(() -> new TreeSet<>(Comparator.comparing(DmSygdMxLj::getUniqueData))), ArrayList::new)
            );
            for (DmSygdMxLj dmSygdMxLj : list) {
                DmSygdMx init = this.initByOther(item, dmSygdMxLj);
                if (item.getQwbBs()) {
                    init.setQbs("1");
                    init.setJssj(item.getQwbjs());
                }
                addList.add(init);
            }
        }
        return addList;
    }

    private List<DmSygdMx> initByYklm(YdjhImport item, List<DmSygdMxLj> bomList) {
        List<DmSygdMx> addList = new ArrayList<>();
        ArrayList<DmSygdMxLj> list = bomList.stream().collect(
                Collectors.collectingAndThen(
                        Collectors.toCollection(() -> new TreeSet<>(Comparator.comparing(DmSygdMxLj::getUniqueData))), ArrayList::new)
        );
        for (DmSygdMxLj dmSygdMxLj : list) {
            DmSygdMx init = this.initByOther(item, dmSygdMxLj);
            this.updateByYklm(item,init);
            if (item.getQwbBs()) {
                init.setQbs("1");
                init.setJssj(item.getQwbjs());
            }
            addList.add(init);
        }
        return addList;
    }

    private List<DmSygdMx> initByYksk(YdjhImport item, List<DmSygdMxLj> bomList) {
        List<DmSygdMx> addList = new ArrayList<>();
        ArrayList<DmSygdMxLj> list = bomList.stream().collect(
                Collectors.collectingAndThen(
                        Collectors.toCollection(() -> new TreeSet<>(Comparator.comparing(DmSygdMxLj::getUniqueData))), ArrayList::new)
        );
        for (DmSygdMxLj dmSygdMxLj : list) {
            DmSygdMx init = this.initByOther(item, dmSygdMxLj);
            this.updateByYksk(item,init);
            if (item.getQwbBs()) {
                init.setQbs("1");
                init.setJssj(item.getQwbjs());
            }
            addList.add(init);
        }
        return addList;
    }

    private List<DmSygdMx> initByEklmbs(YdjhImport item, List<DmSygdMxLj> bomList) {
        List<DmSygdMx> addList = new ArrayList<>();
        ArrayList<DmSygdMxLj> list = bomList.stream().collect(
                Collectors.collectingAndThen(
                        Collectors.toCollection(() -> new TreeSet<>(Comparator.comparing(DmSygdMxLj::getUniqueData))), ArrayList::new)
        );
        for (DmSygdMxLj dmSygdMxLj : list) {
            DmSygdMx init = this.initByOther(item, dmSygdMxLj);
            this.updateByEklm(item,init);
            if (item.getQwbBs()) {
                init.setQbs("1");
                init.setJssj(item.getQwbjs());
            }
            addList.add(init);
        }
        return addList;
    }

    private List<DmSygdMx> initByEksk(YdjhImport item, List<DmSygdMxLj> bomList) {
        List<DmSygdMx> addList = new ArrayList<>();
        ArrayList<DmSygdMxLj> list = bomList.stream().collect(
                Collectors.collectingAndThen(
                        Collectors.toCollection(() -> new TreeSet<>(Comparator.comparing(DmSygdMxLj::getUniqueData))), ArrayList::new)
        );
        for (DmSygdMxLj dmSygdMxLj : list) {
            DmSygdMx init = this.initByOther(item, dmSygdMxLj);
            this.updateByEksk(item,init);
            if (item.getQwbBs()) {
                init.setQbs("1");
                init.setJssj(item.getQwbjs());
            }
            addList.add(init);
        }
        return addList;
    }

    private List<DmSygdMx> initBySksk(YdjhImport item, List<DmSygdMxLj> bomList) {
        List<DmSygdMx> addList = new ArrayList<>();
        ArrayList<DmSygdMxLj> list = bomList.stream().collect(
                Collectors.collectingAndThen(
                        Collectors.toCollection(() -> new TreeSet<>(Comparator.comparing(DmSygdMxLj::getUniqueData))), ArrayList::new)
        );
        for (DmSygdMxLj dmSygdMxLj : list) {
            DmSygdMx init = this.initByOther(item, dmSygdMxLj);
            this.updateBySksk(item,init);
            if (item.getQwbBs()) {
                init.setQbs("1");
                init.setJssj(item.getQwbjs());
            }
            addList.add(init);
        }
        return addList;
    }

    private List<DmSygdMx> initBySkpt(YdjhImport item, List<DmSygdMxLj> bomList) {
        List<DmSygdMx> addList = new ArrayList<>();
        ArrayList<DmSygdMxLj> list = bomList.stream().collect(
                Collectors.collectingAndThen(
                        Collectors.toCollection(() -> new TreeSet<>(Comparator.comparing(DmSygdMxLj::getUniqueData))), ArrayList::new)
        );
        for (DmSygdMxLj dmSygdMxLj : list) {
            DmSygdMx init = this.initByOther(item, dmSygdMxLj);
            this.updateBySkpt(item,init);
            if (item.getQwbBs()) {
                init.setQbs("1");
                init.setJssj(item.getQwbjs());
            }
            addList.add(init);
        }
        return addList;
    }

    private List<DmSygdMx> initBySkbs(YdjhImport item, List<DmSygdMxLj> bomList) {
        List<DmSygdMx> addList = new ArrayList<>();
        ArrayList<DmSygdMxLj> list = bomList.stream().collect(
                Collectors.collectingAndThen(
                        Collectors.toCollection(() -> new TreeSet<>(Comparator.comparing(DmSygdMxLj::getUniqueData))), ArrayList::new)
        );
        for (DmSygdMxLj dmSygdMxLj : list) {
            DmSygdMx init = this.initByOther(item, dmSygdMxLj);
            this.updateBySkbs(item,init);
            if (item.getQwbBs()) {
                init.setQbs("1");
                init.setJssj(item.getQwbjs());
            }
            addList.add(init);
        }
        return addList;
    }

    private void updateByYklm(YdjhImport item, DmSygdMx dmSygdMx) {
        dmSygdMx.setKw("7");
        dmSygdMx.setQgrq(item.getYkpkjs());
        dmSygdMx.setHxrq(item.getYkpkjs());
    }

    private void updateByYksk(YdjhImport item, DmSygdMx dmSygdMx) {
        dmSygdMx.setKw("8");
        dmSygdMx.setQgrq(item.getYkpkjs());
        dmSygdMx.setHxrq(item.getYkpkjs());
    }

    private void updateByEklm(YdjhImport item, DmSygdMx dmSygdMx) {
        dmSygdMx.setKw("5");
        dmSygdMx.setQgrq(item.getLmqgks());
        dmSygdMx.setHxrq(item.getLmqgks());
    }

    private void updateByEksk(YdjhImport item, DmSygdMx dmSygdMx) {
        dmSygdMx.setKw("9");
        dmSygdMx.setQgrq(item.getEkskks());
        dmSygdMx.setHxrq(item.getEkskks());
    }

    private void updateBySksk(YdjhImport item, DmSygdMx dmSygdMx) {
        dmSygdMx.setKw("14");
        dmSygdMx.setQgrq(item.getSkskqgks());
        dmSygdMx.setHxrq(item.getSkskqgks());
        dmSygdMx.setQgjs(item.getSkpkjs());
        dmSygdMx.setQjgrq(item.getQptjs());
    }

    private void updateBySkpt(YdjhImport item, DmSygdMx dmSygdMx) {
        dmSygdMx.setKw("6");
        dmSygdMx.setQgrq(item.getPtks());
    }

    private void updateBySkbs(YdjhImport item, DmSygdMx dmSygdMx) {
        dmSygdMx.setKw("15");
        dmSygdMx.setQgrq(item.getSkqgks());
        dmSygdMx.setQgrq(item.getSkqgks());
    }

    private DmSygdMx initDefault(YdjhImport item,String dcPl) {
        DmSygdMx dmSygdMx = new DmSygdMx();
        dmSygdMx.setDcCh(item.getDcCh());
        if(!"1".equals(item.getExtData())){
            dmSygdMx.setDcCh1(item.getExtData());
        }
        dmSygdMx.setDcPl(dcPl);
        dmSygdMx.setJssj(item.getFdxq());
        dmSygdMx.setSlrq(item.getSl());
        dmSygdMx.setXcpw(item.getXcpw());
        dmSygdMx.setPwrq(item.getPw());
        dmSygdMx.setLlrq(item.getPw());
        if (item.getQwbBs()) {
            dmSygdMx.setQbs("1");
            dmSygdMx.setJssj(item.getQwbjs());
        }
        return dmSygdMx;
    }

    private DmSygdMx initByOther(YdjhImport item, DmSygdMxLj bom) {
        DmSygdMx dmSygdMx = DmSygdMx.ofWithDmSygdMxlj(bom);
        dmSygdMx.setDcCh(item.getDcCh());
        if(!"1".equals(item.getExtData())){
            dmSygdMx.setDcCh1(item.getExtData());
        }
        dmSygdMx.setDcPl(bom.getPl());
        dmSygdMx.setDcFd(bom.getFd());
        dmSygdMx.setSlrq(item.getSl());
        dmSygdMx.setXcpw(item.getXcpw());
        dmSygdMx.setPwrq(item.getPw());
        dmSygdMx.setJssj(item.getFdxq());
        dmSygdMx.setSlrq(item.getSl());
        dmSygdMx.setXcpw(item.getXcpw());
        dmSygdMx.setPwrq(item.getPw());
        dmSygdMx.setLlrq(item.getPw());
        if (item.getQwbBs()) {
            dmSygdMx.setQbs("1");
            dmSygdMx.setJssj(item.getQwbjs());
        }
        return dmSygdMx;
    }

    /**
     * @param dcCh    月度计划导入的船号
     * @param bomList 有可能由目标船只获取
     */
    private List<DmSygdMxLj> initLj(String dcCh, HashMap<Object, DmSygdxq> map, List<DmBom> bomList) {
        List<DmSygdMxLj> list = new ArrayList<>();

        for (DmBom bom : bomList) {
            DmSygdxq dmSygdxq = map.get(dcCh + bom.getPl() + bom.getFd());
            DmSygdMxLj dmSygdMxLj = new DmSygdMxLj();
            dmSygdMxLj.setDcch(dcCh);
            dmSygdMxLj.setPl(bom.getPl());
            dmSygdMxLj.setFd(bom.getFd());
            if (dmSygdxq != null) {
                dmSygdMxLj.setXzglxq(dmSygdxq.getXzglxq());
                dmSygdMxLj.setDzglxq(dmSygdxq.getDzglxq());
            }
            if (!dcCh.equals(bom.getDcch())) {
                dmSygdMxLj.setMbch(bom.getDcch());
            }
            BeanUtil.copyProperties(bom, dmSygdMxLj);

            list.add(dmSygdMxLj);
        }
        return list;
    }
}
